// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'starter.controllers', 'nvd3', 'ngStorage','ngCordova'])

.run(function($ionicPlatform) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if(window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
    }
    if(window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }
var cordovaRef = window.PhoneGap || window.cordova || window.Cordova;
  if (cordovaRef) {
      gaSuccess = function(result) {}
      gaError = function(result) {}
      window.plugins.gaPlugin.init(gaSuccess, gaError, "UA-56296943-1", 10);
	    window.plugins.gaPlugin.trackEvent( gaSuccess, gaError, "Application", "Start", "Started App", 1);
  }
});
})


.config(function($stateProvider, $urlRouterProvider) {
  $stateProvider

    .state('app', {
      url: "/app",
      abstract: true,
      templateUrl: "templates/menu.html",
      controller: 'AppCtrl'
    })

    .state('app.search', {
      url: "/search",
      views: {
        'menuContent' :{
          templateUrl: "templates/search.html"
        }
      }
    })

    .state('app.browse', {
      url: "/browse",
      views: {
        'menuContent' :{
          templateUrl: "templates/browse.html"
        }
      }
    })
    .state('app.hello', {
      url: "/hello",
      views: {
        'menuContent' :{
          templateUrl: "templates/hello.html",
          controller: 'HelloCtrl'
        }
      }
    })
    .state('app.graphs', {
      url: "/graphs/:kidId",
      views: {
        'menuContent' :{
          templateUrl: "templates/graphs.html",
          controller: 'GraphsCtrl'
        }
      }
    })
    .state('app.single', {
      url: "/kids/:kidId",
      views: {
        'menuContent' :{
          templateUrl: "templates/kids.html",
          controller: 'KidsCtrl'
        }
      }
    })
;
  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/app/hello');
})

.config(['$ionicTabsConfig', function($ionicTabsConfig) {
  // Override the Android platform default to add "tabs-striped" class to "ion-tabs" elements.
  $ionicTabsConfig.type = '';
}])

;

