angular.module('starter.controllers', [])

.controller('AppCtrl', function($scope, $ionicModal, $timeout) {
})

.controller('PlaylistsCtrl', function($scope) {
  $scope.playlists = [
    { title: 'Reggae', id: 1 },
    { title: 'Chill', id: 2 },
    { title: 'Dubstep', id: 3 },
    { title: 'Indie', id: 4 },
    { title: 'Rap', id: 5 },
    { title: 'Cowbell', id: 6 }
  ];
})

.controller('KidsCtrl', function($scope, $stateParams, $localStorage, $ionicModal, $filter, $cordovaDatePicker) {
	$scope.$store = $localStorage;
	if (!$scope.$store.kids) 
		$scope.$store.kids = [];
		$scope.id = $stateParams.kidId;
		if ($scope.id == "") {
			$scope.$store.kids.push(
				{
				name: "Your Child",
				dob:(new Date().toJSON().slice(0,10)),
				sex: "",
				records: []
				}
			);
			$scope.id = $scope.$store.kids.length-1
		}

	$scope.kid = $scope.$store.kids[$scope.id];
	$scope.kids = $scope.$store.kids;

$scope.fixDate = function(date) {
        var array = date.split("/");
        //alert(array[0], array[1], array[2]);
        if (array[1]) {
            var day = array[2], month = array[1];
            if (day <= 9)
                day = "0" + day;
            if (month <= 9)
                month = "0" + month;
            date = array[0] + "-" + month + "-" + day;            
        }
    return date;
};

    $scope.kid.dob = $scope.fixDate($scope.kid.dob); 
    angular.forEach($scope.kid.records, function(record, index) {
        record.mdate = $scope.fixDate(record.mdate);
     });  

	console.log($scope.kid);
		
	$ionicModal.fromTemplateUrl('templates/addrecord.html', {
    scope: $scope
  }).then(function(modal) {
    $scope.modal = modal;
  });
	$scope.editRecord = function(recId) {
		$scope.modal.show(); 	

		$scope.editedId = recId;
		$scope.u = (recId=="new")? {mdate: (new Date().toJSON().slice(0,10)), weightlb : "", weightoz : "" , weight : "", height: "", heightin: "", head:"", headin:""}
 : $scope.kid.records[recId];
	
	};
	$scope.ready = true;
	
	$scope.updateMetric =  function() {
  		$scope.u.weight = (Math.round(($scope.u.weightlb + (parseFloat($scope.u.weightoz / 16))) * 45.359237)) || "";
 		$scope.u.height = (Math.round($scope.u.heightin * 2.54)) || "";
 		$scope.u.head = (Math.round($scope.u.headin * 2.54)) || "";
	};
	$scope.updateImperial = function() {
    	nearExact = $scope.u.weight / 453.59237;
    	lbs = Math.floor(nearExact); 
    	oz = (nearExact - lbs) * 16;
  		$scope.u.weightlb =  lbs || "";
  		$scope.u.weightoz =  Math.round(oz) || ""; 
 		$scope.u.heightin = (Math.round($scope.u.height / 0.254)/10) || "";
 		$scope.u.headin = (Math.round($scope.u.head / 0.254)/10) || "";

	};

  
  $scope.saveRecord = function(u) {
    $scope.modal.hide();
	if ($scope.editedId != 'new') $scope.kid.records.splice($scope.editedId, 1);         
	if (u) {
		$scope.kid.records.push(u);
	}
		$scope.kid.records.sort(function(b,a) {return (new Date(a.mdate) > new Date(b.mdate)) ? 1 : ((new Date(b.mdate) > new Date(a.mdate)) ? -1 : 0);} );
		$scope.$store.kids[$scope.id] = $scope.kid;	
	var gaPlugin = window.plugins.gaPlugin;
	gaSuccess = function(result) {}
	gaError = function(result) {}
	gaPlugin.trackEvent( gaSuccess, gaError, "Edit", "Child", "EditChild", 1);

	console.log($scope.$store.kids)
  };


$scope.selectDOB = function(datetarget) {
var options = {date: new Date($scope.kid.dob), mode: 'date'};
  $cordovaDatePicker.show(options).then(function(date){
      if (date != "cancel" ) {
//        date = $scope.fixDate(date);
        $scope.kid.dob=$scope.fixDate(date);
        }
    
  });
};

$scope.selectuDate = function(datetarget) {
var options = {date: new Date($scope.u.mdate), mode: 'date'};
  $cordovaDatePicker.show(options).then(function(date){
    if (date != "cancel" ) {
        //alert(date);
//        date = $scope.fixDate(date)
        //alert(date);
        $scope.u.mdate=$scope.fixDate(date);
    } 
  });
};


	
})

.controller('GraphsCtrl', function($scope, $stateParams, $localStorage, $http) {
var cordovaRef = window.PhoneGap || window.cordova || window.Cordova;
	if (cordovaRef) {
    	gaSuccess = function(result) {}
    	gaError = function(result) {}
    	window.plugins.gaPlugin.trackEvent( gaSuccess, gaError, "View", "Graph", "View Graphs", 1);
    }
	$scope.$store = $localStorage;
	$scope.id = $stateParams.kidId;
	$scope.kid = $scope.$store.kids[$stateParams.kidId];
	$scope.data = [];
	
	console.log($scope.kid);

// weight graph:

	$scope.counts = {};
	$scope.options = {};
	$http.get('data/weight.json')
       .then(function(res){
		   		$scope.wdata = res.data;
		   		$scope.wgraph = getGraphData(res.data, 'weight');
        });
	$http.get('data/height.json')
       .then(function(res){
		   		$scope.hdata = res.data;
		   		$scope.hgraph = getGraphData(res.data, 'height');
        });
	$http.get('data/head.json')
       .then(function(res){
		   		$scope.hhdata = res.data;
		   		$scope.hhgraph = getGraphData(res.data, 'head');
        });


        $scope.templateoptions = {
            chart: {
                type: 'lineChart',
				interpolate: 'basis', // cardinal / basis
//                height: 450,
				showLegend: false,
				
                margin : {
                    top: 20,
                    right: 10,
                    bottom: 45,
                    left: 30
                },
                x: function(d){ return d.x; },
                y: function(d){ return d.y; },
                useInteractiveGuideline: false,
                dispatch: {
                    stateChange: function(e){ console.log("stateChange"); },
                    changeState: function(e){ console.log("changeState"); },
                    tooltipShow: function(e){ console.log("tooltipShow"); },
                    tooltipHide: function(e){ console.log("tooltipHide"); }
                },
                xAxis: {
                    tickFormat: function(d){
                        return d3.format('.0f')(d);
                    },
                    axisLabel: 'Weight (kg) / Age (months)'
                },
                yAxis: {
                    tickFormat: function(d){
                        return d3.format('.1f')(d);
                    },
                    axisLabelDistance: 50
                },
                callback: function(chart){
                    console.log("!!! lineChart callback !!!");
                }
            
            }
        };
		$scope.options.weight= angular.copy($scope.templateoptions);
		$scope.options.height=angular.copy($scope.templateoptions);
		$scope.options.head=angular.copy($scope.templateoptions);
		
		$scope.options.height.chart.xAxis.axisLabel = "Height (cm) / Age (months)";
		$scope.options.head.chart.xAxis.axisLabel = "Head Circumference (cm) / Age (months)";
		

        function getGraphData(data, mode) {
            var P3 = [], P10 = [], P25 = [], P50 = [], P75 = [], P90 = [], P97 = [];
			var kG = [], xArray = [], yArray =[];
			var bday = new Date($scope.kid.dob);

            angular.forEach($scope.kid.records, function(record, index) {
				if (record[mode]) {
					value = (mode!="weight") ? record[mode] : record[mode]/1000;
					rday = new Date(record.mdate);
					miliseconds = rday-bday;
					days = miliseconds/(24*60*60*1000);
					months = days/30.4375; // avg length of the month, whatever.
					kG.push({x: months, y: value});
					xArray.push(months);
					yArray.push(value);
				}
			});
			
			minX = Math.min.apply(null, xArray) -3
			maxX = Math.max.apply(null, xArray) +3
			minY = Math.min.apply(null, yArray) -3 - ((mode=="height")? 2 : 0)
 			maxY = Math.max.apply(null, yArray) +3 + ((mode=="height")? 2 : 0)
			$scope.counts[mode] = yArray.length;
			if ( minY < -1 ) minY = -1;
			if ( minX < -1 ) minX = -1;
			
			$scope.options[mode].chart.yDomain = [minY,maxY];
			$scope.options[mode].chart.xDomain = [minX,maxX];
			console.log($scope.counts);

            //Data is represented as an array of {x,y} pairs.
            angular.forEach(data, function(value, index) {
				if ((value.Sex == $scope.kid.sex) && (value.Agemos >= minX - 12 ) && (value.Agemos < maxX + 12)) {
                	P3.push({x: value.Agemos, y: value.P3 });
                	P10.push({x: value.Agemos, y: value.P10 });
                	P25.push({x: value.Agemos, y: value.P25 });
                	P50.push({x: value.Agemos, y: value.P50 });
                	P75.push({x: value.Agemos, y: value.P75 });
                	P90.push({x: value.Agemos, y: value.P90 });
                	P97.push({x: value.Agemos, y: value.P97 });
				}
            });
			console.log(kG);
			
			partialcolor = ($scope.kid.sex == 2) ? "rgba(130,0,100," : "rgba(20,20,150,";
            //Line chart data should be sent as an array of series objects.
            return [
                {
                    values: P3,      //values - represents the array of {x,y} data points
                    key: 'P3', //key  - the name of the series.
                    color: partialcolor+' 0.1)' , //color - optional: choose your own line color.
                },
                {
                    values: P10,      //values - represents the array of {x,y} data points
                    key: 'P10', //key  - the name of the series.
                    color: partialcolor+' 0.2)'  //color - optional: choose your own line color.
                },
                {
                    values: P25,      //values - represents the array of {x,y} data points
                    key: 'P25', //key  - the name of the series.
                    color: partialcolor+' 0.3)'  //color - optional: choose your own line color.
                },
                {
                    values: P50,      //values - represents the array of {x,y} data points
                    key: 'P50', //key  - the name of the series.
                    color: partialcolor+' 0.4)'  //color - optional: choose your own line color.
                },
                {
                    values: P75,      //values - represents the array of {x,y} data points
                    key: 'P75', //key  - the name of the series.
                    color: partialcolor+' 0.3)'  //color - optional: choose your own line color.
                },
                {
                    values: P90,      //values - represents the array of {x,y} data points
                    key: 'P90', //key  - the name of the series.
                    color: partialcolor+' 0.2)'  //color - optional: choose your own line color.
                },
                {
                    values: P97,      //values - represents the array of {x,y} data points
                    key: 'P97', //key  - the name of the series.
                    color: partialcolor+' 0.1)'  //color - optional: choose your own line color.
                },                {
                    values: kG,      //values - represents the array of {x,y} data points
                    key: $scope.kid.name, //key  - the name of the series.
                    color: partialcolor+'1)'  //color - optional: choose your own line color.
                }

            ];
        };


//chart sample

})

.controller('MenuCtrl', function($scope, $localStorage) {
	$scope.$store = $localStorage;
})

.controller('HelloCtrl', function($scope, $localStorage, $location) {	
	$scope.$store = $localStorage;
	$scope.go = function ( path ) {
  $location.path( path );
};
  $scope.removeKid = function(kid) {
	$scope.$store.kids.splice(kid, 1);         
	$scope.$store.kids.sort(function(a,b) {return (a.name > b.name) ? 1 : ((b.name > a.name) ? -1 : 0);} );
	console.log($scope.$store.kids);
	return false;
  };


});
